/* SevSeg Counter Example
 
 Copyright 2020 Dean Reading
 
 This example demonstrates a very simple use of the SevSeg library with a 4
 digit display. It displays a counter that counts up, showing deci-seconds.
 */

#include "SevSeg.h"
SevSeg sevseg;  //Instantiate a seven segment controller object

#include <Encoder.h>
Encoder myEnc(3, 4);

long oldPosition = -999;


int encoderCount = 0;
int timerSetting = 0;
int previewSetting = 0;
int hundredsFlash = 0;
int tensFlash = 0;
int tenthsFlash = 0;
int pressed = 0;

unsigned long tenthsSpeed = 100;
unsigned long tensSpeed = 5000;


void setup() {


  Serial.begin(115200);


  pinMode(0, INPUT_PULLUP);
  pinMode(5, OUTPUT);
  pinMode(13, OUTPUT);
  byte numDigits = 1;
  byte digitPins[] = { 2 };
  byte segmentPins[] = { 6, 7, 8, 9, 10, 11, 12, 13 };
  bool resistorsOnSegments = false;    // 'false' means resistors are on digit pins
  byte hardwareConfig = COMMON_ANODE;  // See README.md for options
  bool updateWithDelays = false;       // Default 'false' is Recommended
  bool leadingZeros = true;            // Use 'true' if you'd like to keep the leading zeros
  bool disableDecPoint = true;         // Use 'true' if your decimal point doesn't exist or isn't connected

  sevseg.begin(hardwareConfig, numDigits, digitPins, segmentPins, resistorsOnSegments,
               updateWithDelays, leadingZeros, disableDecPoint);
  sevseg.setBrightness(20);

  sevseg.setNumber(previewSetting / 10, 1);
}


int timerDebounce = 0;
unsigned long timer = millis();
unsigned long timer2 = millis();
unsigned long flashTimer = millis();

void loop() {

  static int deciSeconds = 0;

  if (digitalRead(0) == 0) {
    pressed = 1;


    if (timerDebounce == 1) {


      timerSetting = previewSetting;
      Serial.print("timer = ");
      Serial.println(timerSetting);
      timerDebounce = 0;
    }


  } else {
    timerDebounce = 1;
    pressed = 0;
  }


  long newPosition = myEnc.read();

  if (newPosition != oldPosition) {

    if (newPosition > oldPosition - 1) {
      if (tensFlash == 1) {
        encoderCount += 10;
      } else if (hundredsFlash == 1) {
        encoderCount += 100;
      } else {
        encoderCount++;
      }
    } else if (newPosition < oldPosition + 1) {

      if (tensFlash == 1) {
        encoderCount -= 10;
      } else if (hundredsFlash == 1) {
        encoderCount -= 100;
      } else {
        encoderCount--;
      }
    }

    encoderCount = abs(encoderCount);
    encoderCount = encoderCount % 20000;

    previewSetting = encoderCount / 2;

    oldPosition = newPosition;


    Serial.println(previewSetting);
    if (previewSetting < 10) {
      tenthsFlash = 1;
      sevseg.setNumber(previewSetting, 1);
    } else {
      tenthsFlash = 0;
    }

    if (previewSetting > 100 && previewSetting < 1000) {
      tensFlash = 1;
      sevseg.setNumber(previewSetting / 100, 1);
    } else {
      tensFlash = 0;
    }

    if (previewSetting >= 1000) {
      hundredsFlash = 1;
      sevseg.setNumber(previewSetting / 1000, 1);
    } else {
      hundredsFlash = 0;
    }


    if (previewSetting >= 10 && previewSetting <= 100) {
      sevseg.setNumber(previewSetting / 10, 1);
    }
  }

  if ((millis() - timer >= (timerSetting * 10)) && (timerSetting != 0)) {
    timer = millis();
    // if (timerSetting != 0)
    // {
    digitalWrite(5, HIGH);
    //}
    //digitalWrite(13, LOW);
    //delay(1);
    ///digitalWrite(A4,LOW);
    //sevseg.setNumber(deciSeconds, 1);
  }


  if ((millis() - timer2 >= (previewSetting * 10)) && (previewSetting != 0)) {
    timer2 = millis();

    digitalWrite(13, LOW);
    //delay(1);
    ///digitalWrite(A4,LOW);
    //sevseg.setNumber(deciSeconds, 1);
  }

    if (millis() - timer > 100) {
    digitalWrite(5, LOW);
    //digitalWrite(13, HIGH);
    //delay(1);
  }


  if (millis() - timer2 > 10) {

    digitalWrite(13, HIGH);
    //delay(1);
  }

  //   if ((millis() - flashTimer >= tenthsSpeed) && tenthsFlash == 1){
  //   flashTimer = millis();

  //   digitalWrite(13, LOW);
  //   //delay(100);
  //   ///digitalWrite(A4,LOW);
  //   //sevseg.setNumber(deciSeconds, 1);
  // }

  // if ((millis() - flashTimer > 10) && tenthsFlash == 1) {

  //   digitalWrite(13, HIGH);
  // }

  //     if ((millis() - flashTimer >= tensSpeed) && tensFlash == 1){
  //   flashTimer = millis();

  //   digitalWrite(13, LOW);
  //   //delay(100);
  //   ///digitalWrite(A4,LOW);
  //   //sevseg.setNumber(deciSeconds, 1);
  // }
  // if ((millis() - flashTimer > 100) && tensFlash == 1) {

  //   digitalWrite(13, HIGH);
  // }


  sevseg.refreshDisplay();  // Must run repeatedly
}

/// END ///
